package com.steerinfo.dil.util;

import feign.RequestTemplate;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;
import java.util.Random;

/**
 * @Description:
 * @Author:HuJianGuo
 * @GreateTime:2022/3/28 18:05
 * @Version:V2.0
 */
public class HttpUtil {
    //get请求
    public static String doGet(String url,String authValue){
        String result = null;
        CloseableHttpClient httpClient = HttpClients.createDefault();
        ResponseHandler<String> responseHandler = new BasicResponseHandler();
        try {
            HttpGet httpGet = new HttpGet(url);
            httpGet.setHeader("Content-type", "application/json");
            httpGet.setHeader("Authorization","Bearer "+authValue);
            result = httpClient.execute(httpGet, responseHandler);
        } catch (Exception e) {
            e.printStackTrace();
        }
        finally {
            try {
                httpClient.close();
            } catch (Exception e) {
                System.out.println(e.getMessage());
            }
        }
        return result ;
    }

    // post请求参数为json格式
    public static String doJsonPost(String url, String json,String authValue) {
        String result = null;
        CloseableHttpClient httpClient = HttpClients.createDefault();
        ResponseHandler<String> responseHandler = new BasicResponseHandler();
        try {
            HttpPost httpPost = new HttpPost(url);
            StringEntity requestEntity = new StringEntity(json, "utf-8");
            requestEntity.setContentEncoding("UTF-8");
            httpPost.setHeader("Content-type", "application/json");
            httpPost.setHeader("Authorization","Bearer "+authValue);
            httpPost.setEntity(requestEntity);
            result = httpClient.execute(httpPost, responseHandler);
        } catch (Exception e) {
            System.out.println(e.getMessage());
        } finally {
            try {
                httpClient.close();
            } catch (Exception e) {
                System.out.println(e.getMessage());
            }
        }
        return result;
    }

    public static String mapToTxt(Map<String,Object> fieldMap) throws Exception {
        Random random = new Random();
        int j;
        String getLine = "\r\n";
        String doubleBar = "--";
        String biaoshi = "----WebKitFormBoundary";
        StringBuffer sb = new StringBuffer();
//        for (int i = 0; i < 16; i++) {
//            j = random.nextInt(MULTIPART_CHARS.length - 2) + 2;
//            sb.append(MULTIPART_CHARS[j]);
//        }
        biaoshi = biaoshi + sb.toString();
        StringBuffer stringBuffer = new StringBuffer();


        for (Map.Entry<String, Object> entity : fieldMap.entrySet()) {
            String name = "Content-Disposition: form-data; name=\"" + entity.getKey() + "\"";
            stringBuffer.append(doubleBar + biaoshi);
            stringBuffer.append(getLine);
            stringBuffer.append(name);
            stringBuffer.append(getLine);
            stringBuffer.append(getLine);
            stringBuffer.append(entity.getValue());
            stringBuffer.append(getLine);
        }
        stringBuffer.append(doubleBar+biaoshi+doubleBar);
        return stringBuffer.toString();
    }

    public static void apply(RequestTemplate template,String token) {
        // header添加token
        template.header("token", token);
    }
}
